package  {
	
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;
	import flash.ui.Keyboard;
	import flash.utils.setTimeout;

	public class Field extends Sprite {
		
		private var fruitScore:int = 0;
		private var score:int = 0;
		private var tf:TextField;
		
		public var maxI:int;
		public var maxJ:int;
		
		public var gameSpeed:int = 300;
		
		public var snake:Snake;
		public var fruit:Fruit;
		
		public function Field(maxI:int, maxJ:int) {
			
			this.maxJ = maxJ;
			this.maxI = maxI;
			
			graphics.lineStyle(1, 0);
			graphics.drawRect(0, 0, maxI * 20, maxJ * 20);
			
			createScoreField();
			addSnake();
			generateFruit();
			startGame();
		}
		
		private function createScoreField():void {
			tf = new TextField();
			tf.y = maxJ * 20 ;
			tf.text = "0";
			addChild(tf);
		}
		
		public function addKeyboard():void {
			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKey);
		}
		
		private function onKey(e:KeyboardEvent):void {
			
			if (e.keyCode == Keyboard.LEFT && snake.dirI != 1) snake.setDir(-1, 0);
			if (e.keyCode == Keyboard.RIGHT && snake.dirI != -1) snake.setDir(1, 0);
			
			if (e.keyCode == Keyboard.UP && snake.dirJ != 1) snake.setDir(0, -1);
			if (e.keyCode == Keyboard.DOWN && snake.dirJ != -1) snake.setDir(0, 1);
				

		}
		
		private function startGame():void {
			setTimeout(move, gameSpeed);
		}
		
		private function move():void {
			
			if (fruitScore > 1) fruitScore--;
			
			if (snake.move(this)){
				setTimeout(move, gameSpeed);
			}else {
				graphics.beginFill(0xff0000);
				graphics.drawRect(0, 0, maxI * 20, maxJ * 20);
				graphics.endFill();
				tf.width = 300;
				tf.text = "Game Over. Final score: " + score;	
			}
		}
		
		private function addSnake():void {
			snake = new Snake();
			snake.setHead(maxI/2, maxJ/2);
			addChild(snake);
		}
		
		public function generateFruit():void {
			
			if (fruit != null) {
				removeChild(fruit);
				score += fruitScore * (300 - gameSpeed);
				tf.text = String(score);
			}
			
			fruit = new Fruit();
			
			while (true) {
				
				fruit.i = maxI * Math.random();
				fruit.j = maxJ * Math.random();
				
				if (!snake.isTouch(fruit.i, fruit.j)) break;
				
			}
			fruitScore = 30;
			addChild(fruit);
			if (gameSpeed > 10) gameSpeed -= 10;
			
		}
		
	}

}